const path = require("path");
const fs = require("fs");

const React = require("react");
const {Provider} = require("react-redux");
const {renderToString} = require("react-dom/server");
const {StaticRouter} = require("react-router-dom");

const {default: configureStore} = require("../src/store");
const {default: App} = require("../src/router/index.js");
const createHistory = require("history").createMemoryHistory;

module.exports = function universalLoader(req, res) {
  const filePath = path.resolve(__dirname, "..", "build", "index.html");
  console.log("ok");
  fs.readFile(filePath, "utf8", (err, htmlData) => {
    if (err) {
      console.error("read err", err);
      return res.status(404).end();
    }
    const context = {};
    // const store = configureStore()
    const markup = renderToString(
      <Provider store={configureStore(createHistory())}>
        <StaticRouter location={req.url} context={context}>
          <App />
        </StaticRouter>
      </Provider>,
    );
    if (context.url) {
      // Somewhere a `<Redirect>` was rendered
      res.redirect(301, context.url);
    } else {
      // we're good, send the response
      const RenderedApp = htmlData.replace("{{SSR}}", markup);
      res.send(RenderedApp);
    }
  });
};
